module System
  module Enemy
    # UGtFNgԍ̏ݒ
    # ƂɃGtFNgݒ肷
    ATTACK_NUMBER_BUTTOM = 121
    ATTACK_NUMBER_LEFT   = 7
    ATTACK_NUMBER_RIGHT  = 8
    ATTACK_NUMBER_TOP    = 9
    
    # _[WAbsGtFNgԍ
    DAMAGE_NUMBER = 124
    
    # G(t[P)
    INVINCIBLETTIME = 30
    
    # UEFCg(t[P)
    ATTACKWAIT = 60
  end
end

#--------------------------------------------------------------------------
#  JX^Gl~[NX
#--------------------------------------------------------------------------
class CustomEnemy < Game_Enemy
  #--------------------------------------------------------------------------
  #  
  #--------------------------------------------------------------------------
  def initialize(enemy_id, event_id)
    super(0, enemy_id)
    self.clear(event_id)
    self.InitTimer()
    self.InitAttackEffect()
    make_actions()
    make_drop_items()
  end
  
  #--------------------------------------------------------------------------
  #  NA
  #--------------------------------------------------------------------------
  def clear(event_id)
    @enemy = $game_map.events[event_id]
    @timers  = {}
    @attackEffects = {}
    @state = false
    
    viewport = Viewport.new()
    @spriteDamage = Sprite_Damage.new(viewport, @enemy)
    @spriteGauge  = Sprite_EnemyGauge.new(viewport, @enemy, self.mhp)
  end
  
  #--------------------------------------------------------------------------
  #  t[XV
  #--------------------------------------------------------------------------
  def update
    # ͈͂ɑ݂Ȃ΍XVȂ(}X܂ł͌)
    return unless @enemy.near_the_screen?(13, 9)
    
    # Ԃ̍XV
    @timers.each_value do |timer| timer.update() end
    
    # HPQ[W̍XV
    @spriteGauge.update()
    
    # _[W`揈̍XV
    @spriteDamage.update()
    
    # G̍XV
    @state.update()
    
    # 񂾂Ƃ̏
    self.Dead()
  end
  
  #--------------------------------------------------------------------------
  #  Ȕ
  #--------------------------------------------------------------------------
  def update_attack
    # vC[G͈͂ɓĂāA[VEFCgIĂƂ
    return unless @state.Aggressive? && !AttackWaitTime? && $game_map.interpreter.running? == false
    
    # UGtFNg
    self.AttackEffect()
    
    # אڂ}XIDvC[ꍇGɗ^_[WԂ
    return self.Attack()
  end
  
    #
  def getEvent
    return enemy.exp
  end
  
  
  #--------------------------------------------------------------------------
  #  T[`^Cv̐ݒ
  #--------------------------------------------------------------------------
  def SetState(state)
    @state = state
  end
  
  #--------------------------------------------------------------------------
  #  ^C}[̏
  #--------------------------------------------------------------------------
  def InitTimer
    @timers["invincible"] = Game_Timer.new()
    @timers["atkwait"]    = Game_Timer.new()
  end
  
  #--------------------------------------------------------------------------
  #  UGtFNg̏ݒ
  #--------------------------------------------------------------------------
  def InitAttackEffect
    # ƂɍUGtFNgZbg
    # 炭GtFNg͕ύX邾낤AGtFNgID͒萔ɂ͂Ȃ
    # keyɂăGtFNgIDvalueƂĐݒ肷
    # : 2 : 4 E: 6 : 8
    self.SetAttackEffect(2, System::Enemy::ATTACK_NUMBER_BUTTOM)
    self.SetAttackEffect(4, System::Enemy::ATTACK_NUMBER_LEFT)
    self.SetAttackEffect(6, System::Enemy::ATTACK_NUMBER_RIGHT)
    self.SetAttackEffect(8, System::Enemy::ATTACK_NUMBER_TOP)
  end
  
  #--------------------------------------------------------------------------
  #  UGtFNg̐ݒ
  #--------------------------------------------------------------------------
  def SetAttackEffect(key, val)
    # ړȊO̒l͖
    case key
      when 2, 4, 6, 8; @attackEffects[key] = val
    end
  end
  
  #--------------------------------------------------------------------------
  #  ݒ肵UGtFNgԂ
  #--------------------------------------------------------------------------
  def GetAttackEffect(dir)
    return @attackEffects[dir]
  end
  
  #--------------------------------------------------------------------------
  #  UGtFNg
  #--------------------------------------------------------------------------
  def AttackEffect()
    # GtFNg̓CxĝꏊɂoȂ̂ŁAUڂ̑O
    # CxgAɃGtFNgo
    # WGame_CharacterNXāASprite_Characterŏ
    # ɊĎāA̔zSpriteset_MapŊǗĂ炵
    # ͖ʓ|
    # ̂ł߂܂AĂɑ΂ēK؂ȃGtFNg\܂
    @enemy.animation_id = self.GetAttackEffect(@enemy.direction)
  end
  
  #--------------------------------------------------------------------------
  #  U
  #--------------------------------------------------------------------------
  def Attack()
    atk = self.atk()
    
    # U͂Ԃ
    # KIDȂnil
    return atk
  end
  
  #--------------------------------------------------------------------------
  #  Uҋ@ԂIĂ邩
  #--------------------------------------------------------------------------
  def AttackWaitTime?
    animTime = $data_animations[GetAttackEffect(@enemy.direction)].frame_max
    animRate = 4
    waitTime = (animTime * animRate) + System::Enemy::ATTACKWAIT
    return Game_Timer.Manager(@timers["atkwait"], waitTime)
  end
  
  #--------------------------------------------------------------------------
  #  _[W
  #--------------------------------------------------------------------------
  def Damage(player, player_atk)
    return if player_atk == nil || 
    Game_Timer.Manager(@timers["invincible"], System::Enemy::INVINCIBLETTIME)
    
    # vC[̑ID
    weapon_id = 0
    weapon_id = player.weapons[0].wtype_id if player.weapons[0] != nil 
    
    # _[WvZ
    damage = self.MakeDamageValue(player, player_atk, weapon_id)
    
    # NeBJ
    if rand < self.CriticalRate(player, weapon_id)
      damage = self.MakeCriticalValue(player, damage.to_i, weapon_id)
      @spriteDamage.SetColor(System::Color.OrangeRed)
      @spriteDamage.SetSize(32)
    end
    
    # _[W
    self.hp -= damage
    
    # IuWFNgȂԂ
    return if @state.object
    
    # HPQ[W̕\
    @spriteGauge.Draw(self.hp)
    
    # _[W\
    @spriteDamage.Draw(damage.to_i)
    
    # _[W󂯂AbsGtFNg
    self.DamageEffect()
  end
  
  #--------------------------------------------------------------------------
  #  _[WvZ
  #--------------------------------------------------------------------------
  def MakeDamageValue(user, dmg, weapon_id)
    value  = dmg
    value *= element_rate(user.atk_elements[0])
    value -= self.def
    value  = apply_variance(value, self.VarianceRate(user, weapon_id))
    value  = 1 if value <= 0
    return value
  end
  
  #--------------------------------------------------------------------------
  #  U
  #--------------------------------------------------------------------------
  def VarianceRate(user, weapon_id)
    result = 0
    case weapon_id
      when System::Weapon::AX; result = user.atk / 2
      else result = user.atk / 6
    end
    
    return result
  end
  
  #--------------------------------------------------------------------------
  #  NeBJ
  #--------------------------------------------------------------------------
  def CriticalRate(user, weapon_id)
    result = 0
    case weapon_id
      when System::Weapon::AX; result = user.luk.to_f / 2
      else result = user.luk.to_f
    end
    
    return result / 100
  end
  
  #--------------------------------------------------------------------------
  #  NeBJvZ
  #--------------------------------------------------------------------------
  def MakeCriticalValue(user, dmg, weapon_id)
    result = 0
    case weapon_id
      when System::Weapon::AX; result = dmg * 3
      else result = dmg * 2
    end
      
    return result
  end
  
  #--------------------------------------------------------------------------
  #  _[WAbsGtFNg
  #--------------------------------------------------------------------------
  def DamageEffect
    @enemy.animation_id = System::Enemy::DAMAGE_NUMBER
  end
  
  #--------------------------------------------------------------------------
  #  񂾂Ƃ̏
  #--------------------------------------------------------------------------
  def Dead
    return unless self.Dead? && @state.Dead?
    # Cxgy[W̃NA
    @enemy.clear_page_settings()
    
    # z񂩂r
    event_id = $game_map.event_id_xy(@enemy.x, @enemy.y)
    $game_customenemies.erase(event_id)
  end
  
  #--------------------------------------------------------------------------
  #  ł邩H
  #--------------------------------------------------------------------------
  def Dead?
    return self.hp <= 0
  end
end
