#
#  HUD Class
#

class Window_HUD < Window_Base

#--------------------------------------------------------------------------
#  initialize
#--------------------------------------------------------------------------
  def initialize(x, y)
    super(HUD_SETTINGS::Position_X, HUD_SETTINGS::Position_Y, HUD_SETTINGS::Width, HUD_SETTINGS::Height)
	self.opacity = 0
	init_member
  end
  
#--------------------------------------------------------------------------
#  ϐ̏
#--------------------------------------------------------------------------
	def init_member
		@isOverlap = false
		@opac = 255
		@hudVisible = $game_switches[HUD_SETTINGS::Switch] 
		@actor = $game_actors[1]
	end
  

#--------------------------------------------------------------------------
#  ʍXV
#-------------------------------------------------------------------------- 	
  def refresh
    self.contents.clear
    @actor = $game_actors[1]
  	@hp = @actor.hp
	@lv = @actor.level
	@xp = @actor.exp
	@mp = @actor.mp
	@hunger = $game_variables[Val::HUNGER]
	draw_ui
  end
  
#--------------------------------------------------------------------------
#  update
#-------------------------------------------------------------------------- 	
  def update
	super
	
	if @hudVisible == true
	
		# LʍɗUIsx
		if $game_player.screen_x < 300 && $game_player.screen_y < 220
			if !@isOverlap
				@isOverlap = true
				@opac = 128
				refresh
			end
		elsif @isOverlap
			@isOverlap = false
			@opac = 255
			refresh
		end
	
		if $game_message.busy? || $game_message.visible
				self.visible = false
		else
				self.visible = true
		end
	
		if @hp != @actor.hp or @mp != @actor.mp
			refresh
		end
		
		# 󕠓x
		if @hunger != $game_variables[Val::HUNGER]
			refresh
		end
	
	end
	
	# XCb`ςꍇXV
	if @hudVisible != $game_switches[HUD_SETTINGS::Switch] 
		if $game_switches[HUD_SETTINGS::Switch] 
			show
		else
			hide
		end
	end

  end
  
#--------------------------------------------------------------------------
#  e퍀ڂ̕`
#-------------------------------------------------------------------------- 
	def draw_ui
		# e퍀ڂ`
	draw_background
	draw_hpbar
	#draw_mpbar
	draw_hunger
	# tHg
	draw_actor_hp(@actor, HUD_SETTINGS::HpTextX, HUD_SETTINGS::HpTextY)
	#draw_actor_mp(@actor, HUD_SETTINGS::MpTextX, HUD_SETTINGS::MpTextY)
	end
	
  
#--------------------------------------------------------------------------
#  wi̕`
#-------------------------------------------------------------------------- 
	def draw_background
		begin
			bg_bitmap = Cache.system(HUD_SETTINGS::Background)
			bg_rect = Rect.new(0,0,bg_bitmap.width,bg_bitmap.height)
			contents.stretch_blt(Rect.new(0, 0, bg_bitmap.width,bg_bitmap.height), bg_bitmap, bg_rect,@opac)
			bg_bitmap.dispose
		rescue
			p("Class.Window_HUD : LoadImageError(Background)")
		end
	end
	
#--------------------------------------------------------------------------
#  HPo[̕`
#-------------------------------------------------------------------------- 
	def draw_hpbar
		begin
			hp_bitmap = Cache.system(HUD_SETTINGS::HP_Image)
			if @actor.hp_rate == 0
				mhp = 0
			else
				mhp = hp_bitmap.width / @actor.hp_rate
			end
			hp_rect = Rect.new(0,0,mhp,hp_bitmap.height)
			contents.stretch_blt(Rect.new(HUD_SETTINGS::HPBarPositionX, HUD_SETTINGS::HPBarPositionY, hp_bitmap.width, hp_bitmap.height), hp_bitmap, hp_rect,@opac)
			hp_bitmap.dispose
		rescue
			p("Class.Window_HUD : LoadImageError(Hp)")
		end
	end
	
#--------------------------------------------------------------------------
#  MPo[̕`
#-------------------------------------------------------------------------- 
	def draw_mpbar
		begin
			mp_bitmap = Cache.system(HUD_SETTINGS::MP_Image)
			
			if @actor.mp_rate == 0
				mmp = 0
			else
				mmp = mp_bitmap.width / @actor.mp_rate
			end

			mp_rect = Rect.new(0,0,mmp,mp_bitmap.height)
			contents.stretch_blt(Rect.new(HUD_SETTINGS::MpPosX, HUD_SETTINGS::MpPosY, mp_bitmap.width, mp_bitmap.height), mp_bitmap, mp_rect,@opac)
			mp_bitmap.dispose
		rescue
			p("Class.Window_HUD : LoadImageError(Mp)")
		end
	end
	
#--------------------------------------------------------------------------
#  󕠓x̕`
#-------------------------------------------------------------------------- 
	def draw_hunger
	apple = @hunger -1 
	
		if apple >= 0
			for i in 0..apple
				begin
					apple_bitmap = Cache.system(HUD_SETTINGS::SPImage)
					apple_rect = Rect.new(0,0,apple_bitmap.width,apple_bitmap.height)
					contents.stretch_blt(Rect.new(HUD_SETTINGS::SpPosX + HUD_SETTINGS::SpOffset * i, HUD_SETTINGS::SpPosY, apple_bitmap.width,apple_bitmap.height), apple_bitmap, apple_rect,@opac)
					apple_bitmap.dispose
				rescue
				end
			end
		end
	end
	
	
	def show
		self.visible = true
		@hudVisible = true
		$game_switches[HUD_SETTINGS::Switch] = true
	end
	
	def hide
		self.visible = false
		@hudVisible = false
		$game_switches[HUD_SETTINGS::Switch] = false
	end
	
#--------------------------------------------------------------------------
#  HP̕`
#-------------------------------------------------------------------------- 

  def draw_actor_hp(actor, x, y, width = 124)
		draw_current_and_max_values(x, y, width, actor.hp, actor.mhp,
		hp_color(actor), normal_color)
	end
	

#--------------------------------------------------------------------------
#  MP ̕`
#--------------------------------------------------------------------------
  def draw_actor_mp(actor, x, y, width = 124)
    draw_current_and_max_values(x, y, width, actor.mp, actor.mmp,
      mp_color(actor), normal_color)
  end
  
end


#--------------------------------------------------------------------------
#  I[o[Ch
#-------------------------------------------------------------------------- 
class Scene_Map < Scene_Base
  alias arpg_Window_Create start
  def start
    arpg_Window_Create
    @hud_window = Window_HUD.new(HUD_SETTINGS::Position_X, HUD_SETTINGS::Position_Y)
  end
end
